{-# LANGUAGE DerivingVia #-}
{-# LANGUAGE DeriveGeneric #-}
module Language.Java.Classfile (Classfile(..)) where
import Language.Java.Classfile.Version (Version)
import Language.Java.Classfile.Magic (Magic)
import GHC.Generics (Generic, Generically(Generically))
import Language.Java.Classfile.Extractable (Extractable)
import Language.Java.Classfile.ConstantPool (ConstantPool)

data Classfile = Classfile
  { magic        :: Magic
  , version      :: Version
  , constantPool :: ConstantPool
  , accessFlags  :: AccessFlags
  }
  deriving stock (Show, Generic)
  deriving Extractable via Generically Classfile
