{-# LANGUAGE GeneralizedNewtypeDeriving #-}
{-# LANGUAGE DataKinds #-}
{-# LANGUAGE DerivingVia #-}
{-# LANGUAGE DeriveGeneric #-}
module Language.Java.Classfile.ConstantPool.References (Utf8Reference(..), ClassReference(..), NameAndTypeReference(..), MethodHandleReferenceKind(..), OpaqueReference(..), BootstrapMethodIndex(..)) where
import Data.Word (Word16)
import Language.Java.Classfile.Extractable (Extractable)
import Language.Java.Classfile.Extractable.WithTag (Word8Tag)
import GHC.Generics (Generically(..), Generic)

newtype Utf8Reference = Utf8Reference Word16
  deriving stock (Show)
  deriving newtype Extractable

newtype ClassReference = ClassReference Word16
  deriving stock (Show)
  deriving newtype Extractable

newtype NameAndTypeReference = NameAndTypeReference Word16
  deriving stock (Show)
  deriving newtype Extractable

newtype OpaqueReference = OpaqueReference Word16
  deriving stock (Show)
  deriving newtype Extractable

newtype BootstrapMethodIndex = BootstrapMethodIndex Word16
  deriving stock (Show)
  deriving newtype Extractable

data MethodHandleReferenceKind
  = GetField            (Word8Tag 1 ()) -- I kind of want to redo this
  | GetStatic           (Word8Tag 2 ())
  | PutField            (Word8Tag 3 ())
  | PutStatic           (Word8Tag 4 ())
  | InvokeVirtual       (Word8Tag 5 ())
  | InvokeStatic        (Word8Tag 6 ())
  | InvokeSpecial       (Word8Tag 7 ())
  | NewInvokeSpecial    (Word8Tag 8 ())
  | InvokeInterface     (Word8Tag 9 ())
  deriving stock (Show, Generic)
  deriving Extractable via Generically MethodHandleReferenceKind
