{-# LANGUAGE InstanceSigs #-}
module Language.Java.Classfile.FromBigEndian (FromBigEndian(fromBigEndian)) where
import Data.Word (Word16, byteSwap16, Word32, byteSwap32)
import GHC.ByteOrder (ByteOrder(..))
import qualified GHC.ByteOrder as GHC

class FromBigEndian a where
  fromBigEndian :: a -> a

instance FromBigEndian Word16 where
  fromBigEndian :: Word16 -> Word16
  fromBigEndian = case GHC.targetByteOrder of
    LittleEndian -> byteSwap16
    BigEndian    -> id

instance FromBigEndian Word32 where
  fromBigEndian :: Word32 -> Word32
  fromBigEndian = case GHC.targetByteOrder of
    LittleEndian -> byteSwap32
    BigEndian    -> id

